# wepy 图片转base64插件


## 安装

```
npm install wepy-plugin-imgbase64 --save-dev
```

## 配置`wepy.config.js`

```
module.exports.plugins = {
    'imgbase64': {
        css: true,
        html: true,
		output: 'dist',
        path: '/src/img'
    }
};
```


## 参数说明
```
css: 是否读取css中的本地图片路径，并转换成base64
html: 读取<image>中的src属性，判断是本地图片路径，是否转换成base64
output: wepy编译输出目录，默认是'dist'
path: 图片存放路径

删除转换之后成base64之后的图片在输出目录（dist)中的源文件
```
