'use strict';

Object.defineProperty(exports, "__esModule", {
	value: true
});

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

var _path = require('path');

var _path2 = _interopRequireDefault(_path);

var _fs = require('fs');

var _fs2 = _interopRequireDefault(_fs);

var _mime = require('mime');

var _mime2 = _interopRequireDefault(_mime);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

var _class = function () {
	function _class() {
		var c = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : {};

		_classCallCheck(this, _class);

		this.setting = Object.assign({}, {
			css: true,
			html: false,
			output: 'dist'
		}, c);
	}

	_createClass(_class, [{
		key: 'apply',
		value: function apply(op) {
			var _this = this;

			var code = op.code,
			    file = op.file;

			if (code && !/app\.js/.test(file)) {
				var reg = /(\.{0,2}\/)+?(\w+?\/)+(\S+?)\.(png|jpg|gif|jpeg)(\?\w*)?/gi;
				var imgPaths = code.match(reg) || [];
				imgPaths.map(function (imgPath) {
					//匹配(?|&)_origin后缀，不转换为base64
					var isorigin = imgPath.match(/(\?|\&)\_origin/gi);
					if (!!isorigin) {
						op.code = op.code.replace(isorigin[0], '');
						return;
					}

					imgPath = imgPath.match(/(\.{0,2}\/)+?(\w+?\/)+(\S+?)\.(png|jpg|gif|jpeg)/gi)[0];
					var pathFile = _path2.default.join(process.cwd(), _this.setting.path || '', imgPath);
					try {
						var bData = _fs2.default.readFileSync(pathFile);
						var base64Str = bData.toString('base64');
						var mimeType = _mime2.default.lookup(pathFile);
						var dataUri = 'data:' + mimeType + ';base64,' + base64Str;
						op.code = op.code.replace(imgPath, '' + dataUri);

						var delPath = pathFile.replace("src", _this.setting.output);
						_fs2.default.unlink(delPath, function (err) {
							if (err) {
								console.log('[权限不足] ' + delPath);
							} else {
								console.log('[成功删除] ' + delPath);
							}
						});
					} catch (e) {
						console.error('读取图片失败:', pathFile);
					}
				});
			}
			op.next();
		}
	}]);

	return _class;
}();

exports.default = _class;